<?php

if (!defined('CMS')) { die('Access Denied!'); }

$row = array();
$row = $db->selectRow("SELECT `u`.*, `v`.*,
                      (SELECT COUNT(1) FROM ?_users_wall WHERE `wall_user` = `u`.`users_login`) AS `wall`
                       FROM ?_users `u` LEFT JOIN ?_users_visit `v`
                       ON `u`.`users_login` = `v`.`visit_user`
                       WHERE `u`.`users_id` = ? LIMIT 1;", $user_id);

if (empty($row) || !is_array($row)) {

    $inSes->addMessage('Ошибка! Пользователь с данным логином не найден!');
    redirect($config['site_url']);
}

if ($row['users_ban'] == 1) {

    $inSes->addMessage('Ошибка! Пользователь заблокирован!');
    redirect($config['site_url']);
}

if ($config['allow_regkeys'] > 0 && $row['users_confirmreg'] > 0) {

    $inSes->addMessage('Ошибка! Пользователя не существует!');
    redirect($config['site_url']);
}

$nickname = nickname($row['users_login']);

show_header('Анкета ' . $nickname);

echo '<div class="bl"><table><tr>';
echo '<td style="min-height:35px;;">' . user_avatars($row['users_login']) . '</td>';
echo '<td valign="top" style="padding-left:5px;">';
echo user_visit_icon($row['users_login'], $row['users_gender'], $row['visit_nowtime']) . ' <b>' . $nickname . ' </b><br />';
echo user_title($row['users_login']) . '</td>';
echo '</tr></table></div>';
echo '<div class="bl">';

if (!empty($row['users_first_name'])) {

    echo 'Имя: <b>' . $row['users_first_name'] . '</b><br />';
}

if (!empty($row['users_last_name'])) {

    echo 'Фамилия: <b>' . $row['users_last_name'] . '</b><br />';
}

echo 'Пол: ';

if ($row['users_gender'] == 1) {

      echo 'Мужской <br />';
}
else if ($row['users_gender'] == 2) {

      echo 'Женский<br />';
}
else {

      echo 'Не указан<br />';
}

if (!empty($row['users_birthday'])) {

    $tms = strtotime($row['users_birthday']);
    $age = calc_age($tms);
    $get = getdate($tms);

    echo 'Дата рождения: ' . get_date(strtotime($row['users_birthday']), 'j F Y') . ', ' . $lang['date'][$get['weekday']] . '<br />';
    echo 'Возраст: ' . num2name($age, array('лет','года','год')) . '<br />';
    echo 'По гороскопу: ' . znakZodiaka($row['users_birthday']) . '<br />';

    unset($age, $get, $tms);
}

$show = array();

if (!empty($row['users_country']) && !empty($countries[$row['users_country']])) {

    $show[] = $countries[$row['users_country']];
}

if (!empty($row['users_region']) && $row['users_region'] != 'Unknown') {

    $show[] = $row['users_region'];
}

if (!empty($row['users_city']) && $row['users_city'] != 'Unknown') {

    $show[] = $row['users_city'];
}

if (!empty($show)) echo 'Откуда: ' . implode(', ', $show) . '<br />';

if (!empty($row['users_site'])) {

    echo 'Сайт: <a href="http://' . $row['users_site'] . '" target="_blank">http://' . $row['users_site'] . '</a><br />';
}

if (!empty($row['users_info'])) {

    echo 'О себе: ' . nl2br(bb_code($row['users_info'])) . '<br />';
}

echo '</div>';

$show = array();

if (!empty($row['users_icq'])) {

    $show[] = '<img src="http://web.icq.com/whitepages/online?icq=' . $row['users_icq'] . '&amp;img=27" class="icon" alt="" /> ';
    $show[] = 'ICQ: ' . $row['users_icq'] . '<br />';
}

if (!empty($row['users_skype'])) {

    $show[] = '<img src="http://mystatus.skype.com/smallicon/' . $row['users_skype'] . '" class="icon" alt="" /> ';
    $show[] = 'Skype: ' . $row['users_skype'] . ' <br />';
}

if (!empty($row['users_jabber'])) {

    $show[] = 'Jabber: ' . $row['users_jabber'] . ' <br />';
}

if (!empty($show)) echo '<div class="bl">' . implode('', $show) . '</div>';

if ($row['users_rating'] > 0) {

    $row['users_rating'] = '<span style="color:#00aa00">+' . $row['users_rating'] . '</span>';
}

if ($row['users_rating'] < 0) {

    $row['users_rating'] = '<span style="color:#ff0000">' . $row['users_rating'] . '</span>';
}

echo '<div class="bl">';
echo icon('star.png');
echo 'Рейтинг: <b>' . num2name($row['users_point'],$config['score_name']) . '</b><br />';

echo icon('best.png');
echo '<a href="' . gen_uri('rating_history', '', RND) . '">Авторитет</a>: ';
echo '<b>' . $row['users_rating'] . '</b> (+' . $row['users_posrating'] . '/-' . $row['users_negrating'] . ') ';

if ($is_logged && $log <> $row['users_login']) {

    echo '[ <a href="' . gen_users($row['users_id'], 'rating', 1, 'rnd=' . $_SESSION['token']) . '" title="Плюс">
            <img src="/images/icons/up.gif" alt="Плюс" />
            <span style="color:#0099cc"> Плюс</span></a> | ';
    echo '<a href="' . gen_users($row['users_id'], 'rating', 2, 'rnd=' . $_SESSION['token']) . '" title="Минус">
            <img src="/images/icons/down.gif" alt="Минус" />
            <span style="color:#ff0000">Минус</span></a> ]<br />';
}

echo '</div>';

if (!empty($_GET['stat'])) {

    echo show_link(gen_uri('anketa', '', RND), 'Статистика');

    echo '<div class="bl" id="stat">';
    echo 'Всего посeщений: <b>' . num($row['users_visits']) . '</b><br />';
    echo 'Сообщений в чате: <b>' . num($row['users_allchat']) . '</b><br />';
    echo 'Записей в блогах: <b>' . num($row['users_allforum']) . '</b><br />';
    echo 'Комментариев: <b>' . num($row['users_allcomments']) . '</b><br />';
    //echo 'Актив: ' . num2name($row['users_point'], $config['score_name']) . '<br />';
    echo 'На руках: ' . num2name($row['users_money'], $config['money_name']) . '<br />';

    if ($row['users_sumcredit'] > 0) {

        echo 'Задолженность по кредиту: ' . moneys($row['users_sumcredit']) . '<br />';
    }

    echo 'Используемый скин: ' . $row['users_themes'] . '<br />';
    echo 'Дата регистрации: ' . get_date($row['users_joined'], 'j F Y') . '<br />';
    echo 'Последняя авторизация: ' . get_date($row['users_timelastlogin']) . '<br />';

    if (!empty($row['visit_alltime'])) {

        echo 'Провел на сайте: ' . makestime($row['visit_alltime']) . '<br />';
        echo 'Всего переходов: ' . num($row['visit_allcount']) . '<br />';
    }

    echo 'Строгих нарушений: <b>' . num($row['users_totalban']) . '</b><br />';
    echo '</div>';
}
else {

    echo show_link(gen_uri('anketa', '', 'stat=1&amp;' . RND . '#stat'), 'Статистика');
}

if (is_admin(array(101, 102, 103))) {

    echo show_link(gen_admin('?m=ban_user&amp;uz=' . $row['users_login']), 'Бан / Разбан');
} 

if (is_admin(array(101, 102))) {

    echo show_link(gen_admin('?m=users_edit&amp;uz=' . $row['users_login']), 'Редактировать');
}

    echo show_link(gen_uri('index', '', RND), 'Личка ' . $row['users_login']);

?>